/*
    Copyright (C) 2012 Bartosz Broda, Jacek Bochenek, Łukasz Biłeńkij, 
    Damian Jaworski, Wojciech Mazur, Dominik Piasecki, Maciej Piasecki, 
    Radosław Ramocki
    
    This program is free software; you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published by the Free
Software Foundation; either version 3 of the License, or (at your option)
any later version.

    This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. 

    See the LICENSE and COPYING files for more details.
*/

#include "../comparator_stdheaders.h"
#include "Jaccard.h"

namespace smartcomparator
{
	namespace simfunctions
	{
		Jaccard::Jaccard(Matrices::SuperMatrixPtr m)
			: SimilarityFunction(m)
		{
		}

		Jaccard::~Jaccard(void)
		{
		}

		double Jaccard::CountSimilarity(Matrices::CompressedVector& v1, Matrices::CompressedVector& v2,
			size_t , size_t , const std::set<size_t> &v1Ind, const std::set<size_t> &v2Ind)
		{
			double fraction = 0;
			double sqr1 = 0;
			double sqr2 = 0;

			std::set<size_t> intersection;

			std::set_intersection(v1Ind.begin(), v1Ind.end(), v2Ind.begin(), v2Ind.end(),
				std::insert_iterator< std::set<size_t> >(intersection, intersection.begin()));

			for(std::set<size_t>::const_iterator iter = intersection.begin(); iter != intersection.end();iter++)
			{
				double v1Val = (v1)[(*iter)];
				double v2Val = (v2)[(*iter)];
				fraction += v1Val * v2Val;
			}

			for(std::set<size_t>::const_iterator iter = v1Ind.begin(); iter != v1Ind.end(); ++iter)
			{
				double v1Val = (v1)[(*iter)];
				sqr1 += v1Val * v1Val;
			}

			for(std::set<size_t>::const_iterator iter = v2Ind.begin(); iter != v2Ind.end(); ++iter)
			{
				double v2Val = (v2)[(*iter)];
				sqr2 += v2Val * v2Val;
			}
			return fraction/(sqr1 + sqr2 - fraction);
		}


		double Jaccard::MinValue() const
		{
			return 0;
		}


		double Jaccard::CountSimilarity(Matrices::CompressedVector& v1, Matrices::CompressedVector& v2,
			const std::set<size_t> &v1Ind, const std::set<size_t> &v2Ind)
		{
			return CountSimilarity(v1,v2,-1,-1, v1Ind, v2Ind);
		}

	}
}
